precision mediump float; //指定默认精度

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float iGlobalTime;

float psAdd(float a, float b){
    if(a<=.5){
        return a * b * 2.;
    } else {
        return 1. - 2. *(1. -a)*(1.-b);
    }
}

vec3 hsb2rgb( in vec3 c ){
    vec3 rgb = clamp(abs(mod(c.x*6.0+vec3(0.0,4.0,2.0),
                             6.0)-3.0)-1.0,
                     0.0,
                     1.0 );
    rgb = rgb*rgb*(3.0-2.0*rgb);
    return c.z * mix(vec3(1.0), rgb, c.y);
}

void main() {
    float time = iGlobalTime * 40.;

    //float beats[10] = float[10](1., 0., 1., 0., .5, .5, .5, 0., 1., 1.);
    float beats[10];
    beats[0] = 1.;
    beats[1] = 0.;
    beats[2] = 1.;
    beats[3] = 0.;
    beats[4] = .5;
    beats[5] = .5;
    beats[6] = .5;
    beats[7] = 0.;
    beats[8] = 1.;
    beats[9] = 1.;

    float progress =( cos(time + 3.14159) / 2. + .5 ) * beats[int(floor(mod(time /2./ 3.14159, 10.)))];
    float timesPi = time / 2. / 3.14159 + .5;
    float colorIndex = floor(mod(timesPi, 7.)) / 6.;

    vec4 colorOri = texture2D(inputImageTexture, textureCoordinate);

    vec3 color = hsb2rgb(vec3(colorIndex,1.0,1.0));
    vec4 colorAdd = vec4(mix(color, vec3(0.,0.,0.), textureCoordinate.y), 1.);

    vec4 white = vec4(1.);
    vec4 colorRet = white - (white - colorOri) * (white - colorAdd);

    gl_FragColor = mix(colorOri, colorRet, progress);

}