precision mediump float; //指定默认精度

varying highp vec2 textureCoordinate;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform float ratio;
uniform int is_gray;
uniform int dimension;

void main()
 {
     lowp vec4 textureColor = texture2D(inputImageTexture, textureCoordinate);
     lowp float dimensionCol = sqrt(float(dimension));

     mediump float blueColor = textureColor.b * pow(dimensionCol, 2.0)-1.0;

     mediump vec2 quad1;
     quad1.y = floor(floor(blueColor) / dimensionCol);
     quad1.x = floor(blueColor) - (quad1.y * dimensionCol);

     mediump vec2 quad2;
     quad2.y = floor(ceil(blueColor) / dimensionCol);
     quad2.x = ceil(blueColor) - (quad2.y * dimensionCol);

     lowp float den = pow(2.0*dimensionCol, 2.0);
     highp vec2 texPos1;
     texPos1.x = (quad1.x / dimensionCol) + 0.5/den + ((1.0/dimensionCol - 1.0/den) * textureColor.r);
     texPos1.y = (quad1.y / dimensionCol) + 0.5/den + ((1.0/dimensionCol - 1.0/den) * textureColor.g);

     highp vec2 texPos2;
     texPos2.x = (quad2.x / dimensionCol) + 0.5/den + ((1.0/dimensionCol - 1.0/den) * textureColor.r);
     texPos2.y = (quad2.y / dimensionCol) + 0.5/den + ((1.0/dimensionCol - 1.0/den) * textureColor.g);

     lowp vec4 newColor1 = texture2D(inputImageTexture2, texPos1);
     lowp vec4 newColor2 = texture2D(inputImageTexture2, texPos2);

     lowp vec4 newColor = mix(newColor1, newColor2, fract(blueColor));
     if(is_gray > 0){
        gl_FragColor = mix(textureColor.ggga, vec4(newColor.rgb, textureColor.w), ratio);
     }else{
        gl_FragColor = mix(textureColor, vec4(newColor.rgb, textureColor.w), ratio);
     }
 }
