precision highp float;
uniform float  iGlobalTime;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

float rand () {
    return fract(sin(iGlobalTime)*1e4);
}
void main( )
{
    vec2 uv = textureCoordinate.xy ;

    vec2 uvR = uv;
    vec2 uvB = uv;

    uvR.x = uv.x * 1.0 - rand() * 0.02 * 0.8;
    uvB.y = uv.y * 1.0 + rand() * 0.02 * 0.8;

    //
    if(uv.y < rand() && uv.y > rand() -0.1 && sin(iGlobalTime) < 0.0)
    {
        uv.x = (uv + 0.02 * rand()).x;
    }

    //
    vec4 c;
    c.r = texture2D(inputImageTexture, uvR).r;
    c.g = texture2D(inputImageTexture, uv).g;
    c.b = texture2D(inputImageTexture, uvB).b;

    //
    float scanline = sin( uv.y * 800.0 * rand())/30.0;
    c *= 1.0 - scanline;

    //vignette
    float vegDist = length(( 0.5 , 0.5 ) - uv);
    c *= 1.0 - vegDist * 0.6;

    gl_FragColor = c;
}