precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float iGlobalTime;

void main()
{
    float c = 2.;
    float speedTime = 1.5 * iGlobalTime;
    float s = mod(ceil(speedTime), 2.);

    float mx = textureCoordinate.x + s*(step(textureCoordinate.y, .5) * 2. - 1.) * fract(speedTime) * .5 + 1.;
    float my = textureCoordinate.y - (1.-s) *(step(textureCoordinate.x, .5) * 2. - 1.) * fract(speedTime) * .5 + 1.;

    vec2 uv = fract(vec2(mx, my) * c);

    gl_FragColor = texture2D(inputImageTexture, uv);

}
