precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float iGlobalTime;

vec2 scaleuv(vec2 uv, float s){
    return (uv - vec2(0.5, 0.5)) * s + vec2(0.5, 0.5);
}

void main()
{
    vec2 uv = textureCoordinate;
    float f = fract(iGlobalTime * 1.5);
    f = f * step(f, 0.5);
    float scale = 1.0 - 0.8 * f;
    vec4 color1 = texture2D(inputImageTexture, uv);
    vec4 color2 = texture2D(inputImageTexture, scaleuv(uv, scale));

    gl_FragColor = color1 * 0.8  + color2 * 0.2;
}