precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float iGlobalTime;

vec2 scaleuv(vec2 uv, float s){
    return (uv - vec2(0.5, 0.5)) * s + vec2(0.5, 0.5);
}

vec2 rotateuv(vec2 uv, float a){
    vec2 uvc = uv - vec2(0.5, 0.5);
    return vec2(uvc.x * cos(a) - uvc.y * sin(a), uvc.x * sin(a) + uvc.y * cos(a)) + vec2(0.5, 0.5);
}

void main()
{
    vec2 uv = textureCoordinate;
    float alpha = iGlobalTime * 4.0;
    float s = 1. - step(1., fract(alpha / 4.0 / 3.1415) * 2.);
    float f = sin(alpha) * s;
    float scale = 1.0 - 0.25 * f;
    vec4 color = texture2D(inputImageTexture, scaleuv(rotateuv(uv, f * 0.05), scale));

    gl_FragColor = color;
}
