precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float iGlobalTime;

vec2 scaleuv(vec2 uv, float s){
    return (uv - vec2(0.5, 0.5)) * s + vec2(0.5, 0.5);
}

void main()
{
    vec2 uv = textureCoordinate;
    float f = fract(iGlobalTime * 1.5);
    f = f * step(f, 0.5);
    float offsetr = 0.04 * f;
    float offsetb = 0.02 * f;
    float scale = 1.0 - 0.3 * f;
    float r = texture2D(inputImageTexture, scaleuv(uv + vec2(-offsetr, offsetr), scale)).r;
    float b = texture2D(inputImageTexture, scaleuv(uv + vec2(-offsetb, offsetb), scale)).b;
    vec4 color1 = texture2D(inputImageTexture, scaleuv(uv , scale));

    gl_FragColor = vec4(color1.r * 0.2 + r * 0.8, color1.g, color1.b * 0.6 + b * 0.4, 1.);
}